    import FetchService from './service/FetchService.js';

/*-- Objects --*/
const fetchService = new FetchService();
/*-- /Objects --*/
const corsAnywhere = "https://cors-anywhere.herokuapp.com/";
const yourUrl ="https://pretix.eu/api/v1/organizers/madridcff/events/abonos22-23/orders/"
/*--Functions--*/
async function submitForm(e, form) {
    // 1. Prevent reloading page
    e.preventDefault();
    // 2. Submit the form
    // 2.1 User Interaction
    const btnSubmit = document.getElementById('btnSubmit');
    btnSubmit.disabled = true;
    setTimeout(() => btnSubmit.disabled = false, 2000);
    // 2.2 Build JSON body
    const jsonFormData = buildJsonFormData(form);
    // 2.3 Build Headers
    console.log(jsonFormData);
    const headers = buildHeaders();
    // 2.4 Request & Response
    const response = await fetchService.performPostHttpRequest(corsAnywhere + yourUrl, headers, jsonFormData ); // Uses JSON Placeholder
    console.log(response);
    // 2.5 Inform user of result
    if(response)
        console.log(response);
        //window.location = `/success.html?FirstName=${response.FirstName}&LastName=${response.LastName}&Email=${response.Email}&id=${response.id}`;
    else
        alert(`An error occured.`);
}

function buildHeaders(authorization = null) {
    const headers = {
        "Content-Type": "application/json",
        "Authorization": "Token 88ajy42qsm80rmykvilbdmao7bpj4ym5x93ozzlh7msldt6qo39ipqlp8i83x7l2" 
        };
    return headers;
}

function buildJsonFormData(form) {
    const jsonFormData = {
        "email": sampleForm.email.value,
        "locale": "en",
        "sales_channel": "web",
        "fees": [],
        "payment_provider": "boxoffice",
        "invoice_address": {
            "is_business": false,
            "company": "Madrid CFF INVITACIONES",
            "name_parts": { "full_name": "Madrid CFF INVITACIONES" },
            "street": "Madrid CFF INVITACIONES",
            "zipcode": "28037",
            "city": "Madrid",
            "country": "ES",
            "state": "",
            "internal_reference": "",
            "vat_id": ""
        },
        "positions": [],
        "send_email": true

    };
   /* for(const pair of new FormData(form)) {
        jsonFormData[positions] = pair[1];
    }*/
    const entradas = {
      
        "item": 299523,
        "variation": null,
        "price": "0.00",
        "attendee_name": sampleForm.FirstName.value,
        "attendee_email": sampleForm.email.value,
        "addon_to": null,
        "answers": [],
        "subevent": null

    }
  
    for (var i = 0; i < sampleForm.CantidadEntradas.value; i++) {
        // console.log(i);
        const n = i + 1;
        const positionid = { "positionid": n, }
        
    jsonFormData.positions[i] = positionid;
    jsonFormData.positions[i] = entradas;
        
    }






    return jsonFormData;
}
/*--/Functions--*/

/*--Event Listeners--*/
const sampleForm = document.querySelector("#sampleForm");
if(sampleForm) {
    sampleForm.addEventListener("submit", function(e) {
        submitForm(e, this);
    });
}
/*--/Event Listeners--*/
